////////////////////////////////////////////////////////////////////////
// edit_timer.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.edit_timer")

// <%pre>
#line 1 "edit_timer.ecpp"

#include <memory>
#include <vdr/channels.h>
#include <vdr/config.h>
#include <vdr/epg.h>
#include <vdr/i18n.h>
#include "exception.h"
#include "tools.h"
#include "timers.h"
#include "setup.h"
#include "epg_events.h"
#include "timerconflict.h"
#include "i18n.h"
#include "livefeatures.h"
#include "epgsearch.h"
#include "users.h"

using namespace std;
using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("edit_timer");

static const char* rawData = "\010\001\000\000,\001\000\0005\001\000\0007\001\000\000:\001\000\000;\001\000\000L\001"
  "\000\000N\001\000\000Q\001\000\000R\001\000\000\226\001\000\000\341\001\000\000\020\002\000\000\317\002\000\0005\003"
  "\000\000\257\003\000\000\344\003\000\000L\004\000\000\201\004\000\000\362\004\000\0002\005\000\000\214\005\000\000"
  "\333\005\000\000\372\005\000\000<\006\000\000\303\006\000\000\335\006\000\000\337\006\000\000\372\006\000\000\002\007"
  "\000\000\014\007\000\0006\007\000\000y\007\000\000\344\007\000\000<\010\000\000\310\010\000\000\352\010\000\000d\t"
  "\000\000\206\t\000\000\000\n\000\000\"\n\000\000\234\n\000\000\276\n\000\0009\013\000\000[\013\000\000\325\013\000"
  "\000\367\013\000\000q\014\000\000\223\014\000\000\004\015\000\000l\015\000\000\263\015\000\000\013\016\000\000q\016"
  "\000\000\266\016\000\000\016\017\000\000b\017\000\000\270\017\000\000!\020\000\000y\020\000\000\342\020\000\000\223"
  "\021\000\000\337\021\000\000W\022\000\000|\022\000\000}\022\000\000\n<html>\n\t<head>\n\t\t<title>VDR Live - </title>"
  "\n\t\t\n\t\t\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<form method=\"post\" name=\"edit_ti"
  "mer\" id=\"\" action=\"edit_timer.ecpp\">\n\t\t\t\t<input type=\"hidden\" name=\"timerid\" value=\"\"/>\n\t\t\t\t<inp"
  "ut type=\"hidden\" name=\"aux\" value=\"\"/>\n\t\t\t\t<table class=\"formular\" cellpadding=\"0\" cellspacing=\"0\">"
  "\n\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t<td class=\"toprow leftcol rightcol\" colspan=\"2\"><div class=\"boxhead"
  "er\"><div><div class=\"caption\"></div></div></div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\""
  "label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<div class"
  "=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"active_1\" name=\"active\" value=\"1\"  type=\"radio\"></input>\n\t\t\t\t\t"
  "\t\t\t<label for=\"active_1\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<"
  "input id=\"active_0\" name=\"active\" value=\"0\"  type=\"radio\"></input>\n\t\t\t\t\t\t\t\t<label for=\"active_0\"><"
  "/label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label le"
  "ftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><div class=\"withmargin\"></div></"
  "td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td"
  ">\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"title\" value=\"\" size=\"80\" /></td>\n\t\t\t\t\t<"
  "/tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td"
  " class=\"rightcol\"><select name=\"directory\" size=\"1\" id=\"directory\" style=\"margin-top: 5px\">\n\t\t\t\t\t\t  "
  "   <option/>\n\t\t    \t\t\t\t\t<option value=\"\"\n\t\t\t\t\t\t\tselected=\"selected\"\n\t\t\t\t\t\t\t></option>\n\t"
  "\t\t\t\t\t   </select>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\""
  "><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input id=\"date\" name=\"date\" type=\"t"
  "ext\" class=\"DatePicker\" value=\"\" /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftc"
  "ol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<div class=\"dotted\""
  ">\n\t\t\t\t\t\t\t\t<input id=\"wday_mon\" type=\"checkbox\" name=\"wday_mon\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label"
  " for=\"wday_mon\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"w"
  "day_tue\" type=\"checkbox\" name=\"wday_tue\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_tue\"></label>\n\t\t"
  "\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"wday_wed\" type=\"checkbox\" name"
  "=\"wday_wed\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_wed\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t"
  "<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"wday_thu\" type=\"checkbox\" name=\"wday_thu\" value=\"1\"  />\n"
  "\t\t\t\t\t\t\t\t<label for=\"wday_thu\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t"
  "\t\t\t\t\t<input id =\"wday_fri\" type=\"checkbox\" name=\"wday_fri\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"w"
  "day_fri\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"wday_sat"
  "\" type=\"checkbox\" name=\"wday_sat\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_sat\"></label>\n\t\t\t\t\t"
  "\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"wday_sun\" type=\"checkbox\" name=\"wda"
  "y_sun\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_sun\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n"
  "\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t"
  "\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" size=\"2\" maxlength=\"2\" name=\"start_h\" value=\"\" /> : <in"
  "put type=\"text\" size=\"2\" maxlength=\"2\" name=\"start_m\" value=\"\" /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n"
  "\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><i"
  "nput type=\"text\" size=\"2\" maxlength=\"2\" name=\"end_h\" value=\"\" /> : <input type=\"text\" size=\"2\" maxlengt"
  "h=\"2\" name=\"end_m\" value=\"\" /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\""
  "><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"checkbox\" name=\"vps\" val"
  "ue=\"1\" /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin"
  "\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" size=\"2\" maxlength=\"2\" name=\"priority\""
  " value=\"\" /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmarg"
  "in\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" size=\"2\" maxlength=\"2\" name=\"lifetime"
  "\" value=\"\" /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"buttonpanel leftcol rightcol bottom"
  "row\" colspan=\"2\">\n\t\t\t\t\t\t\t<div class=\"withmargin\">\n\t\t\t\t\t\t\t<button class=\"green\" type=\"submit\""
  "></button>\n\t\t\t\t\t\t\t<button type=\"button\" class=\"red\" onclick=\"history.back()\"></button>\n\t\t\t\t\t\t\t<"
  "/div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t\t<div style=\"color: red; margin: 0 "
  "auto;\">\n\t\t\t\t\n\t\t\t</div>\n\t\t</div>\n\t</body>\n</html>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("edit_timer " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string timerid = tnt::stringTo<string>("timerid", "string", qparam.param("timerid"), reply.out().getloc());
string epgid = tnt::stringTo<string>("epgid", "string", qparam.param("epgid"), reply.out().getloc());
string async = tnt::stringTo<string>("async", "string", qparam.param("async"), reply.out().getloc());
tChannelID channel = tnt::stringTo<tChannelID>("channel", "tChannelID", qparam.param("channel"), reply.out().getloc());
int active = qparam.has("active") ? tnt::stringToWithDefault<int>(qparam.param("active"), ( 1), reply.out().getloc()) : ( 1);
string title = qparam.has("title") ? tnt::stringToWithDefault<string>(qparam.param("title"), ( ""), reply.out().getloc()) : ( "");
string date = qparam.has("date") ? tnt::stringToWithDefault<string>(qparam.param("date"), ( ""), reply.out().getloc()) : ( "");
bool wday_mon = qparam.has("wday_mon") ? tnt::stringToWithDefault<bool>(qparam.param("wday_mon"), ( false), reply.out().getloc()) : ( false);
bool wday_tue = qparam.has("wday_tue") ? tnt::stringToWithDefault<bool>(qparam.param("wday_tue"), ( false), reply.out().getloc()) : ( false);
bool wday_wed = qparam.has("wday_wed") ? tnt::stringToWithDefault<bool>(qparam.param("wday_wed"), ( false), reply.out().getloc()) : ( false);
bool wday_thu = qparam.has("wday_thu") ? tnt::stringToWithDefault<bool>(qparam.param("wday_thu"), ( false), reply.out().getloc()) : ( false);
bool wday_fri = qparam.has("wday_fri") ? tnt::stringToWithDefault<bool>(qparam.param("wday_fri"), ( false), reply.out().getloc()) : ( false);
bool wday_sat = qparam.has("wday_sat") ? tnt::stringToWithDefault<bool>(qparam.param("wday_sat"), ( false), reply.out().getloc()) : ( false);
bool wday_sun = qparam.has("wday_sun") ? tnt::stringToWithDefault<bool>(qparam.param("wday_sun"), ( false), reply.out().getloc()) : ( false);
int start_h = qparam.has("start_h") ? tnt::stringToWithDefault<int>(qparam.param("start_h"), ( 0), reply.out().getloc()) : ( 0);
int start_m = qparam.has("start_m") ? tnt::stringToWithDefault<int>(qparam.param("start_m"), ( 0), reply.out().getloc()) : ( 0);
int end_h = qparam.has("end_h") ? tnt::stringToWithDefault<int>(qparam.param("end_h"), ( 0), reply.out().getloc()) : ( 0);
int end_m = qparam.has("end_m") ? tnt::stringToWithDefault<int>(qparam.param("end_m"), ( 0), reply.out().getloc()) : ( 0);
bool vps = qparam.has("vps") ? tnt::stringToWithDefault<bool>(qparam.param("vps"), ( 0), reply.out().getloc()) : ( 0);
int priority = qparam.has("priority") ? tnt::stringToWithDefault<int>(qparam.param("priority"), ( 0), reply.out().getloc()) : ( 0);
int lifetime = qparam.has("lifetime") ? tnt::stringToWithDefault<int>(qparam.param("lifetime"), ( 0), reply.out().getloc()) : ( 0);
string aux = qparam.has("aux") ? tnt::stringToWithDefault<string>(qparam.param("aux"), ( ""), reply.out().getloc()) : ( "");
string directory = qparam.has("directory") ? tnt::stringToWithDefault<string>(qparam.param("directory"), ( ""), reply.out().getloc()) : ( "");
  // </%args>

#line 50 "edit_timer.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 51 "edit_timer.ecpp"
  typedef string edit_timerreferer_type;
  TNT_SESSION_GLOBAL_VAR(edit_timerreferer_type, edit_timerreferer, "string edit_timerreferer", ());   // <%session> string edit_timerreferer
#line 52 "edit_timer.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_SESSION_GLOBAL_VAR(timerNotifier_type, timerNotifier, "TimerConflictNotifier timerNotifier", ());   // <%session> TimerConflictNotifier timerNotifier
#line 55 "edit_timer.ecpp"
  typedef cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(timer_type, timer, "cTimer* timer", ());   // <%request> cTimer* timer
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 58 "edit_timer.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	if (!cUser::CurrentUserHasRightTo(UR_EDITTIMERS))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

	bool ajaxReq = !async.empty() && (lexical_cast<int>(async) != 0);

	tChannelID channelid = tChannelID();
	tEventID eventid = tEventID();

	string message;
	cMutexLock timersLock( &LiveTimerManager() );
	SortedTimers& timers = LiveTimerManager().GetTimers();

	timer = 0;
	if ( !timerid.empty() ) {
		string tId = SortedTimers::DecodeDomId(timerid);
		// dsyslog("DEBUG: TIMER: tId = %s", tId.c_str());
		timer = timers.GetByTimerId(tId);
		if ( timer == 0 )
			throw HtmlError( tr("Couldn't find timer. Maybe you mistyped your request?") );
	}

	if ( request.getMethod() == "POST" ) {
		uint flags = ( active ? tfActive : 0 ) | ( vps ? tfVps : 0 );
		string weekdays = string( wday_mon ? "M" : "-" ) + ( wday_tue ? "T" : "-" ) + ( wday_wed ? "W" : "-" )
							  + ( wday_thu ? "T" : "-" ) + ( wday_fri ? "F" : "-" ) + ( wday_sat ? "S" : "-" )
							  + ( wday_sun ? "S" : "-" );
		int start = start_h * 100 + start_m;
		int stop = end_h * 100 + end_m;

		if (!directory.empty())
		   title = directory + "~" + title;

		if (title.empty())
			message = tr("Please set a title for the timer!");
		else
		{
			// TRANSLATORS: only adjust the ordering and separators, don't translate the m's, d's and y's
			time_t tdate = GetDateFromDatePicker(date, tr("mm/dd/yyyy"));
			string sdate = DatePickerToC(tdate, "yyyy-mm-dd");
			LiveTimerManager().UpdateTimer( timer, flags, channel, weekdays, sdate, start, stop, priority, lifetime, title, aux );
			timerNotifier.SetTimerModification();
			return reply.redirect(!edit_timerreferer.empty()?edit_timerreferer:"timers.html");
		}
	}

	if (message.empty())
		edit_timerreferer = request.getHeader("Referer:", "timers.html");

	auto_ptr< cTimer > eventTimer;
	if ( timer == 0 && !epgid.empty()) {
		EpgEvents::DecodeDomId(epgid, channelid, eventid);
		if ( channelid.Valid() && eventid != 0 ) {
			cerr << "grabbing event" << endl << endl;
			cSchedulesLock schedLock;
			cSchedules const* schedules = cSchedules::Schedules( schedLock );
			cSchedule const* schedule = schedules->GetSchedule( channelid );

			eventTimer.reset( new cTimer( schedule->GetEvent( eventid ) ) );
		} else {
			cerr << "grabbing new timer" << endl << endl;
			eventTimer.reset( new cTimer() );
			eventTimer->SetFlags( tfActive );
		}
		timer = eventTimer.get();
	}
	if (timer == 0)
	{
	   timer = new cTimer();
	   timer->SetFlags(tfActive);
	}

	if ( timer != 0 ) {
		active = timer->Flags() & tfActive;
		channel = timer->Channel()->GetChannelID();
		title = timer->File() ? timer->File() : "";
		if ( LiveFeatures< features::epgsearch >().Recent() ) {
		   vector< string > directories = StringSplit( title, '~' );
		   if (directories.size() > 1)
		   {
		      directory = directories[0];
		      title = title.substr(directory.size()+1);
		   }
		}
		// TRANSLATORS: only adjust the ordering and separators, don't translate the m's, d's and y's
		date = timer->Day() ? DatePickerToC(timer->Day(), tr("mm/dd/yyyy")) : "";
		wday_mon = timer->WeekDays() & 0x01;
		wday_tue = timer->WeekDays() & 0x02;
		wday_wed = timer->WeekDays() & 0x04;
		wday_thu = timer->WeekDays() & 0x08;
		wday_fri = timer->WeekDays() & 0x10;
		wday_sat = timer->WeekDays() & 0x20;
		wday_sun = timer->WeekDays() & 0x40;
		start_h = ( timer->Start() / 100 ) % 100;
		start_m = timer->Start() % 100;
		end_h = ( timer->Stop() / 100 ) % 100;
		end_m = timer->Stop() % 100;
		vps = timer->Flags() & tfVps;
		priority = timer->Priority();
		lifetime = timer->Lifetime();
		aux = timer->Aux() ? timer->Aux() : "";
	}

  // <& pageelems.doc_type ...
  { 
#line 163 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 163 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR Live - 
#line 166 "edit_timer.ecpp"
  reply.sout() << ( timer ? tr("Edit timer") : tr("New timer") );
  reply.out() << data[1]; // </title>\n
#line 167 "edit_timer.ecpp"

	if (!ajaxReq) {

  reply.out() << data[2]; // \t\t
  // <& pageelems.stylesheets ...
  { 
#line 170 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 170 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[3]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 171 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 171 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[4]; // \n
#line 172 "edit_timer.ecpp"

	}

  reply.out() << data[5]; // \t</head>\n\t<body>\n
#line 177 "edit_timer.ecpp"

	if (!ajaxReq) {

  reply.out() << data[6]; // \t\t
  // <& pageelems.logo ...
  { 
#line 180 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 180 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[7]; // \n\t\t
  // <& menu ...
  { 
#line 181 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 181 "edit_timer.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("timers"), reply.out().getloc() ) );
#line 181 "edit_timer.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[8]; // \n
#line 182 "edit_timer.ecpp"

	}

  reply.out() << data[9]; // \t\t<div class="inhalt">\n\t\t\t<form method="post" name="edit_timer" id="
#line 186 "edit_timer.ecpp"
  reply.sout() << ( timerid );
  reply.out() << data[10]; // " action="edit_timer.ecpp">\n\t\t\t\t<input type="hidden" name="timerid" value="
#line 187 "edit_timer.ecpp"
  reply.sout() << ( timerid );
  reply.out() << data[11]; // "/>\n\t\t\t\t<input type="hidden" name="aux" value="
#line 188 "edit_timer.ecpp"
  reply.sout() << ( aux );
  reply.out() << data[12]; // "/>\n\t\t\t\t<table class="formular" cellpadding="0" cellspacing="0">\n\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t<td class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div><div class="caption">
#line 191 "edit_timer.ecpp"
  reply.sout() << ( timer ? tr("Edit timer") : tr("New timer") );
  reply.out() << data[13]; // </div></div></div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 195 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Active") );
  reply.out() << data[14]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="active_1" name="active" value="1" 
#line 198 "edit_timer.ecpp"
 reply.out() << ( active ? "checked=\"checked\"" : "" ); 
  reply.out() << data[15]; //  type="radio"></input>\n\t\t\t\t\t\t\t\t<label for="active_1">
#line 199 "edit_timer.ecpp"
  reply.sout() << ( trVDR("yes") );
  reply.out() << data[16]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="active_0" name="active" value="0" 
#line 202 "edit_timer.ecpp"
 reply.out() << ( !active ? "checked=\"checked\"" : "" ); 
  reply.out() << data[17]; //  type="radio"></input>\n\t\t\t\t\t\t\t\t<label for="active_0">
#line 203 "edit_timer.ecpp"
  reply.sout() << ( trVDR("no") );
  reply.out() << data[18]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 209 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << data[19]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><div class="withmargin">
  // <& channels_widget ...
  { 
#line 210 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 210 "edit_timer.ecpp"
    _tnt_cq5.add( "channelid", tnt::toString((true), reply.out().getloc() ) );
#line 210 "edit_timer.ecpp"
    _tnt_cq5.add( "name", tnt::toString(("channel"), reply.out().getloc() ) );
#line 210 "edit_timer.ecpp"
    _tnt_cq5.add( "selected", tnt::toString((channel), reply.out().getloc() ) );
#line 210 "edit_timer.ecpp"
    callComp(tnt::Compident(std::string(), "channels_widget"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[20]; // </div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 214 "edit_timer.ecpp"
  reply.sout() << ( tr("Title" ) );
  reply.out() << data[21]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="title" value="
#line 215 "edit_timer.ecpp"
  reply.sout() << ( title );
  reply.out() << data[22]; // " size="80" /></td>\n\t\t\t\t\t</tr>\n
#line 217 "edit_timer.ecpp"

					if ( LiveFeatures< features::epgsearch >().Recent() ) {
					        RecordingDirs recordingdirs(true);

  reply.out() << data[23]; // \t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 222 "edit_timer.ecpp"
  reply.sout() << ( tr("Directory" ) );
  reply.out() << data[24]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="directory" size="1" id="directory" style="margin-top: 5px">\n\t\t\t\t\t\t     <option/>\n
#line 225 "edit_timer.ecpp"

					             for (RecordingDirs::iterator rdir = recordingdirs.begin(); rdir != recordingdirs.end(); ++rdir) {
						        std::string dir = *rdir;

  reply.out() << data[25]; // \t\t    \t\t\t\t\t<option value="
#line 229 "edit_timer.ecpp"
  reply.sout() << ( dir );
  reply.out() << data[26]; // "\n
#line 230 "edit_timer.ecpp"
							if (*rdir == directory) {

  reply.out() << data[27]; // \t\t\t\t\t\t\tselected="selected"\n
#line 232 "edit_timer.ecpp"
							}

  reply.out() << data[28]; // \t\t\t\t\t\t\t>
#line 233 "edit_timer.ecpp"
  reply.sout() << ( dir );
  reply.out() << data[29]; // </option>\n
#line 234 "edit_timer.ecpp"
						}

  reply.out() << data[30]; // \t\t\t\t\t\t   </select>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n
#line 238 "edit_timer.ecpp"

					}

  reply.out() << data[31]; // \n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 243 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Day") );
  reply.out() << data[32]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input id="date" name="date" type="text" class="DatePicker" value="
#line 244 "edit_timer.ecpp"
  reply.sout() << ( date );
  reply.out() << data[33]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 248 "edit_timer.ecpp"
  reply.sout() << ( tr("Weekday") );
  reply.out() << data[34]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_mon" type="checkbox" name="wday_mon" value="1" 
#line 251 "edit_timer.ecpp"
 reply.out() << ( wday_mon ? "checked=\"checked\"" : "" ); 
  reply.out() << data[35]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_mon">
#line 252 "edit_timer.ecpp"
  reply.sout() << ( tr("Monday") );
  reply.out() << data[36]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_tue" type="checkbox" name="wday_tue" value="1" 
#line 255 "edit_timer.ecpp"
 reply.out() << ( wday_tue ? "checked=\"checked\"" : "" ); 
  reply.out() << data[37]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_tue">
#line 256 "edit_timer.ecpp"
  reply.sout() << ( tr("Tuesday") );
  reply.out() << data[38]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_wed" type="checkbox" name="wday_wed" value="1" 
#line 259 "edit_timer.ecpp"
 reply.out() << ( wday_wed ? "checked=\"checked\"" : "" ); 
  reply.out() << data[39]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_wed">
#line 260 "edit_timer.ecpp"
  reply.sout() << ( tr("Wednesday") );
  reply.out() << data[40]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_thu" type="checkbox" name="wday_thu" value="1" 
#line 263 "edit_timer.ecpp"
 reply.out() << ( wday_thu ? "checked=\"checked\"" : "" ); 
  reply.out() << data[41]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_thu">
#line 264 "edit_timer.ecpp"
  reply.sout() << ( tr("Thursday") );
  reply.out() << data[42]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id ="wday_fri" type="checkbox" name="wday_fri" value="1" 
#line 267 "edit_timer.ecpp"
 reply.out() << ( wday_fri ? "checked=\"checked\"" : "" ); 
  reply.out() << data[43]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_fri">
#line 268 "edit_timer.ecpp"
  reply.sout() << ( tr("Friday") );
  reply.out() << data[44]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_sat" type="checkbox" name="wday_sat" value="1" 
#line 271 "edit_timer.ecpp"
 reply.out() << ( wday_sat ? "checked=\"checked\"" : "" ); 
  reply.out() << data[45]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_sat">
#line 272 "edit_timer.ecpp"
  reply.sout() << ( tr("Saturday") );
  reply.out() << data[46]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_sun" type="checkbox" name="wday_sun" value="1" 
#line 275 "edit_timer.ecpp"
 reply.out() << ( wday_sun ? "checked=\"checked\"" : "" ); 
  reply.out() << data[47]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_sun">
#line 276 "edit_timer.ecpp"
  reply.sout() << ( tr("Sunday") );
  reply.out() << data[48]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 282 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << data[49]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" size="2" maxlength="2" name="start_h" value="
#line 283 "edit_timer.ecpp"
  reply.sout() << ( ZeroPad(start_h) );
  reply.out() << data[50]; // " /> : <input type="text" size="2" maxlength="2" name="start_m" value="
#line 283 "edit_timer.ecpp"
  reply.sout() << ( ZeroPad(start_m) );
  reply.out() << data[51]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 287 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Stop") );
  reply.out() << data[52]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" size="2" maxlength="2" name="end_h" value="
#line 288 "edit_timer.ecpp"
  reply.sout() << ( ZeroPad(end_h) );
  reply.out() << data[53]; // " /> : <input type="text" size="2" maxlength="2" name="end_m" value="
#line 288 "edit_timer.ecpp"
  reply.sout() << ( ZeroPad(end_m) );
  reply.out() << data[54]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 292 "edit_timer.ecpp"
  reply.sout() << ( tr("Use VPS") );
  reply.out() << data[55]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="checkbox" name="vps" value="1" 
#line 293 "edit_timer.ecpp"
 reply.out() << ( vps ? "checked=\"checked\"" : "" ); 
  reply.out() << data[56]; // /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 297 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Priority") );
  reply.out() << data[57]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" size="2" maxlength="2" name="priority" value="
#line 298 "edit_timer.ecpp"
  reply.sout() << ( priority );
  reply.out() << data[58]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 302 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Lifetime") );
  reply.out() << data[59]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" size="2" maxlength="2" name="lifetime" value="
#line 303 "edit_timer.ecpp"
  reply.sout() << ( lifetime );
  reply.out() << data[60]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n\t\t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t\t<button class="green" type="submit">
#line 309 "edit_timer.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << data[61]; // </button>\n\t\t\t\t\t\t\t<button type="button" class="red" onclick="history.back()">
#line 310 "edit_timer.ecpp"
  reply.sout() << ( tr("Cancel") );
  reply.out() << data[62]; // </button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t\t<div style="color: red; margin: 0 auto;">\n\t\t\t\t
#line 317 "edit_timer.ecpp"
  reply.sout() << ( message );
  reply.out() << data[63]; // \n\t\t\t</div>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[64]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
