////////////////////////////////////////////////////////////////////////
// error.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.error")

// <%pre>
#line 1 "error.ecpp"

#include <vdr/i18n.h>
#include "setup.h"

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class error_widget_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        error_widget_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    error_widget_type error_widget;
};

static tnt::ComponentFactoryImpl<_component_> Factory("error");

static const char* rawData = "0\000\000\0001\000\000\000U\000\000\000`\000\000\000t\000\000\000w\000\000\000\222\000"
  "\000\000\255\000\000\000\256\000\000\000\375\000\000\000\"\001\000\0007\001\000\000\n\n<html>\n\t<head>\n\t\t<title>V"
  "DR-Live - </title>\n\t\t\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t\n\t\t</div>\n\t</body>"
  "\n</html>\n\t\t<table class=\"error\" cellpadding=\"0\" cellspacing=\"0\">\n\t\t<tr><td class=\"title\"></td></tr>\n"
  "\t\t<tr><td class=\"message\"></td></tr>\n\t</table>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    error_widget(*this, "error_widget")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("error " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
std::string pageTitle = qparam.param("pageTitle");
std::string errorTitle = qparam.param("errorTitle", ( tr("Page error")));
std::string errorMessage = qparam.param("errorMessage");
  // </%args>

#line 14 "error.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
  // <%cpp>
#line 16 "error.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

  reply.out() << data[0]; // \n
  // <& pageelems.doc_type ...
  { 
#line 19 "error.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 19 "error.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[1]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 22 "error.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[2]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 23 "error.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 23 "error.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[3]; // \n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 26 "error.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 26 "error.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 27 "error.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 27 "error.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n\t\t\t
  // <& error.error_widget ...
  { 
#line 29 "error.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 29 "error.ecpp"
    _tnt_cq4.add( "errorMessage", tnt::toString((errorMessage), reply.out().getloc() ) );
#line 29 "error.ecpp"
    _tnt_cq4.add( "errorTitle", tnt::toString((errorTitle), reply.out().getloc() ) );
#line 29 "error.ecpp"
    callComp(tnt::Subcompident(std::string(), "error", "error_widget"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[6]; // \n\t\t</div>\n\t</body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::error_widget_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("error::error_widget " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
std::string errorTitle = qparam.param("errorTitle");
std::string errorMessage = qparam.param("errorMessage");
  // </%args>

#line 14 "error.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
  // <%cpp>
  reply.out() << data[7]; // \t
  reply.out() << data[8]; // \t<table class="error" cellpadding="0" cellspacing="0">\n\t\t<tr><td class="title">
#line 39 "error.ecpp"
  reply.sout() << ( errorTitle );
  reply.out() << data[9]; // </td></tr>\n\t\t<tr><td class="message">
#line 40 "error.ecpp"
  reply.sout() << ( errorMessage );
  reply.out() << data[10]; // </td></tr>\n\t</table>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
