////////////////////////////////////////////////////////////////////////
// login.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.login")

// <%pre>
#line 1 "login.ecpp"

#include "tools.h"
#include "setup.h"
#include "users.h"

using namespace std;
using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("login");

static const char* rawData = "8\000\000\0009\000\000\000]\000\000\000h\000\000\000k\000\000\000\024\001\000\000k\001"
  "\000\000\377\001\000\0007\002\000\000\217\002\000\000\316\002\000\000\036\003\000\000x\003\000\000\245\003\000\000\n"
  "\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t</head>\n\t<body onload=\"document.auth.login.focus"
  "()\">\n\t<div style=\"width: 350px; margin: 0 auto; text-align: center; padding: 20px\">\n\t\t<div class=\"boxheader"
  "\"><div><div></div></div></div>\n\t\t<div style=\"border: 1px solid black; padding: 15px\">\n\t\t\t<img src=\"\" alt="
  "\"VDR Live\"></img>\n\t\t\t<form name=\"auth\">\n\t\t\t\t<input type=\"hidden\" name=\"action\" value=\"login\" />\n"
  "\t\t\t\t<table class=\"login\">\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td>:</td>\n\t\t\t\t\t\t<td><input type=\"text\" name=\""
  "login\" value=\"\" size=\"15\" maxlength=\"15\" /></td>\n\t\t\t\t\t\t<td>&nbsp;</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>"
  "\n\t\t\t\t\t\t<td>:</td>\n\t\t\t\t\t\t<td><input type=\"password\" name=\"password\" value=\"\" size=\"15\" maxlength"
  "=\"15\" /></td>\n\t\t\t\t\t\t<td><button type=\"submit\" class=\"blue\"></td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t"
  "\t\t</form>\n\t\t\t<div style=\"color: red; margin: 0 auto;\">\n\t\t\t\t\n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t</bod"
  "y>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("login " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
std::string login = tnt::stringTo<std::string>("login", "std::string", qparam.param("login"), reply.out().getloc());
std::string password = tnt::stringTo<std::string>("password", "std::string", qparam.param("password"), reply.out().getloc());
std::string action = tnt::stringTo<std::string>("action", "std::string", qparam.param("action"), reply.out().getloc());
  // </%args>

#line 16 "login.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
  // <%cpp>
#line 18 "login.ecpp"


std::string message;

if (action == "login") {
	if (Users.ValidLogin(login, password)) {
		logged_in = true;
		cUsers::logged_in_user = login;
	} else {
		message = tr("Wrong username or password");
	}
} else if (action == "logout") {
	logged_in = false;
	cUsers::logged_in_user = "";
}

LiveSetup().CheckLocalNet(request.getPeerIp());

if (logged_in || !LiveSetup().UseAuth()) return reply.redirect(LiveSetup().GetStartScreenLink());


  reply.out() << data[0]; // \n
  // <& pageelems.doc_type ...
  { 
#line 39 "login.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 39 "login.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[1]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 42 "login.ecpp"
  reply.sout() << ( tr("Login") );
  reply.out() << data[2]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 43 "login.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 43 "login.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[3]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 44 "login.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 44 "login.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[4]; // \n\t</head>\n\t<body onload="document.auth.login.focus()">\n\t<div style="width: 350px; margin: 0 auto; text-align: center; padding: 20px">\n\t\t<div class="boxheader"><div><div>
#line 48 "login.ecpp"
  reply.sout() << ( tr("VDR Live Login") );
  reply.out() << data[5]; // </div></div></div>\n\t\t<div style="border: 1px solid black; padding: 15px">\n\t\t\t<img src="
#line 50 "login.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "logo_login.png") );
  reply.out() << data[6]; // " alt="VDR Live"></img>\n\t\t\t<form name="auth">\n\t\t\t\t<input type="hidden" name="action" value="login" />\n\t\t\t\t<table class="login">\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td>
#line 55 "login.ecpp"
  reply.sout() << ( tr("User") );
  reply.out() << data[7]; // :</td>\n\t\t\t\t\t\t<td><input type="text" name="login" value="
#line 56 "login.ecpp"
  reply.sout() << ( login );
  reply.out() << data[8]; // " size="15" maxlength="15" /></td>\n\t\t\t\t\t\t<td>&nbsp;</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td>
#line 60 "login.ecpp"
  reply.sout() << ( tr("Password") );
  reply.out() << data[9]; // :</td>\n\t\t\t\t\t\t<td><input type="password" name="password" value="
#line 61 "login.ecpp"
  reply.sout() << ( password );
  reply.out() << data[10]; // " size="15" maxlength="15" /></td>\n\t\t\t\t\t\t<td><button type="submit" class="blue">
#line 62 "login.ecpp"
  reply.sout() << ( tr("Login") );
  reply.out() << data[11]; // </td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t\t<div style="color: red; margin: 0 auto;">\n\t\t\t\t
#line 67 "login.ecpp"
  reply.sout() << ( message );
  reply.out() << data[12]; // \n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t</body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
