////////////////////////////////////////////////////////////////////////
// multischedule.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.multischedule")

// <%pre>
#line 1 "multischedule.ecpp"

#include <list>
#include <vdr/plugin.h>
#include <vdr/channels.h>
#include <vdr/epg.h>
#include <vdr/config.h>
#include <vdr/device.h>
#include "exception.h"
#include "livefeatures.h"
#include "setup.h"
#include "tools.h"
#include "timers.h"
#include "epg_events.h"
#include "i18n.h"

using namespace std;
using namespace vdrlive;

struct SchedEntry {
	string title;
	string short_description;
	string description;
	string description_trunc;
	string start;
	string end;
	string day;
	string epgid;
	bool truncated;
	bool has_timer;
	int start_row;
	int row_count;
};

std::string 					channel_groups_setting;
std::vector<std::string>		channel_groups_names;
std::vector< std::vector<int> > channel_groups_numbers;
std::vector<std::string>		times_names;
std::vector<time_t>      		times_start;

#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class channel_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        channel_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    channel_selection_type channel_selection;
};

static tnt::ComponentFactoryImpl<_component_> Factory("multischedule");

static const char* rawData = "\030\001\000\000<\001\000\000G\001\000\000J\001\000\000^\001\000\000a\001\000\000y\001"
  "\000\000\265\001\000\000\007\002\000\000N\002\000\000~\002\000\000\177\002\000\000\214\002\000\000\231\002\000\000"
  "\355\002\000\000\373\002\000\0004\003\000\0007\003\000\000@\003\000\000A\003\000\000L\003\000\000[\003\000\000\230"
  "\003\000\000\322\003\000\000\363\003\000\000#\004\000\000.\004\000\000\255\004\000\000\256\004\000\000\360\004\000"
  "\000\374\004\000\000\005\005\000\000\021\005\000\000G\005\000\000a\005\000\000\240\005\000\000\315\005\000\000\316"
  "\005\000\000\331\005\000\000\021\006\000\000\030\006\000\000V\006\000\000Z\006\000\000x\006\000\000z\006\000\000\177"
  "\006\000\000\241\006\000\000\350\006\000\000\367\006\000\000\377\006\000\000p\007\000\000\237\007\000\000\240\007\000"
  "\000\241\007\000\000\003\010\000\000\205\010\000\000\226\010\000\000\230\010\000\000\257\010\000\000\310\010\000\000"
  "\322\010\000\000\375\010\000\000\203\t\000\000\224\t\000\000\226\t\000\000\255\t\000\000\306\t\000\000\320\t\000\000"
  "\337\t\000\000\362\t\000\000\n<html>\n\t<head>\n\t\t<title>VDR Live - </title>\n\t\t\n\t\t\n\t</head>\n\t<body>\n\t\t"
  "\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t<table class=\"mschedule\" cellspacing=\"0\" cellpadding=\"0\">\n\t       <tr"
  " class=\" topaligned \">\n\t       <td > <div class=\"boxheader\"> <div><div></div></div> </div></td>\n\t       <td c"
  "lass=\"time spacer\"> &nbsp; </td>\n\t       <td> <div class=\"boxheader\"> <div> <div> \n            \n            "
  "\n            </div></div> </div></td>\n\t       <td class=\"time spacer\"> &nbsp; </td>\n\t       </tr>\n\t\t       "
  "<tr>\n\t\t       <td class=\" time leftcol rightcol \">\n\t\t       \n\t\t\t &nbsp;\n\t\t       </td>\n\t\t          "
  "      <td class = \" time spacer \" > &nbsp; </td>\n\t\t\t<td class=\"event topaligned leftcol rightcol\" rowspan=\""
  "\">\n                        </td>\n\t\t\t<td class=\"event topaligned leftcol rightcol \" rowspan=\"\">\n           "
  "             <div class=\" content1 \" >\n                        <div class=\" tools1 \" >\n                        "
  "  \n                          <a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\" ></img></a>\n<img s"
  "rc=\"img/transparent.png\" width=\"16\" height=\"16\">                          \n                         </div><div"
  " class= \"start withmargin\"></div>\n\t\t\t  <div class=\"title withmargin\"><a ></a></div>\n                        "
  "  <div class=\"short withmargin\"></div>\n                          <div class=\"description withmargin\">...\n      "
  "                     <a > </a>\n                           </div>\n                          </div></div>\n          "
  "                </td>\n\t\t       </tr>\n\t\t\t<tr>\n\t\t\t<td class = \" event leftcol rightcol bottomrow \" > &nbsp"
  "; </td>\n\t\t\t<td class = \" time spacer \" > &nbsp; </td>\n\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</ht"
  "ml>\n\n\n<form action=\"multischedule.html\" method=\"get\" id=\"channels\">\n   <span>\n     <label for=\"channel\">"
  ":&nbsp;<span class=\"bold\"></span></label>\n     <select name=\"channel\" id=\"channel\"  onchange=\"document.forms."
  "channels.submit()\" >\n\t\t<option value=\"\"\n\t\t\tselected=\"selected\"\n                        ></option>\n     "
  "</select>\n     <label for=\"time_para\">:&nbsp;<span class=\"bold\"></span></label>\n     <select name=\"time_para\""
  " id=\"time_para\"  onchange=\"document.forms.channels.submit()\" >\n\t\t<option value=\"\"\n\t\t\tselected=\"selected"
  "\"\n                        ></option>\n     </select>\n   </span>\n</form>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    channel_selection(*this, "channel_selection")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("multischedule " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
int channel = qparam.has("channel") ? tnt::stringToWithDefault<int>(qparam.param("channel"), ( -1), reply.out().getloc()) : ( -1);
unsigned int time_para = qparam.has("time_para") ? tnt::stringToWithDefault<unsigned int>(qparam.param("time_para"), ( 0), reply.out().getloc()) : ( 0);
  // </%args>

#line 45 "multischedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 48 "multischedule.ecpp"
  typedef unsigned int channel_group_type;
  TNT_REQUEST_PAGE_VAR(channel_group_type, channel_group, "unsigned int channel_group", (0));   // <%request> unsigned int channel_group(0)
#line 49 "multischedule.ecpp"
  typedef unsigned int time_selected_type;
  TNT_REQUEST_PAGE_VAR(time_selected_type, time_selected, "unsigned int time_selected", (0));   // <%request> unsigned int time_selected(0)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 52 "multischedule.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");
	pageTitle = tr("MultiSchedule");

	ReadLock channelsLock( Channels );
	if ( !channelsLock )
		throw HtmlError( tr("Couldn't aquire access to channels, please try again later.") );

#define MAX_CHANNELS 10
#define MAX_DAYS 3
#define MAX_HOURS 8
#define MINUTES_PER_ROW 5
#define CHARACTERS_PER_ROW 30

    if ( ( channel_groups_setting.compare(LiveSetup().GetChannelGroups()) != 0 ) || ( channel_groups_numbers.size() == 0 ) )
    {
        // build the groups of channels to display
        std::string channelGroups=LiveSetup().GetChannelGroups();
        if ( channelGroups.empty() )
        {
            // setup default channel groups
           int lastChannel = LiveSetup().GetLastChannel();
           if ( lastChannel == 0 )
               lastChannel = Channels.MaxNumber();
           std::stringstream groups;
           int i = 0;
           for (cChannel *channel = Channels.First(); channel && (channel->Number() <= lastChannel); channel = Channels.Next(channel))
           {
               if (channel->GroupSep())
                   continue;
               groups << channel->Number();
               if ( (++i % 5) == 0 )
                   groups << ";";
               else
                   groups << ",";
           }
           channelGroups = groups.str();
           LiveSetup().SetChannelGroups( channelGroups );
        }
        channel_groups_names.clear();
        channel_groups_numbers.clear();
        channel_groups_setting = channelGroups;
        size_t groupSep;
        std::string thisGroup = "";
        while ( ! channelGroups.empty() )
        {
            groupSep = channelGroups.find(';');
            thisGroup = channelGroups.substr(0, groupSep );
            if ( groupSep != channelGroups.npos )
                channelGroups.erase(0, groupSep+1 );
            else
                channelGroups="";

            int cur_group_count=0;
            channel_groups_names.push_back( std::string() );
            channel_groups_numbers.push_back( std::vector<int>() );
            while ( !thisGroup.empty() )
            {
                std::string thisChannel;
                try {
                    if ( cur_group_count != 0 )
                        channel_groups_names.back() += std::string( " - " );
                    size_t channelSep = thisGroup.find(',');
                    thisChannel = thisGroup.substr(0, channelSep );
                    if ( channelSep != thisGroup.npos )
                        thisGroup.erase( 0, channelSep+1 );
                    else
                        thisGroup = "";
                    int channel_no = lexical_cast< int > (thisChannel);
                    cChannel* Channel = Channels.GetByNumber( channel_no );
                    if ( !Channel )
                    {
                        esyslog("Live: could not find channel no '%s'.", thisChannel.c_str() );
                        continue;
                    }
                    channel_groups_names.back() += std::string( Channel->Name() );
                    channel_groups_numbers.back().push_back( Channel->Number() );
                    cur_group_count++;
                    if ( cur_group_count>=MAX_CHANNELS )
                    {
                        // start new group if group gets too large
                        cur_group_count=0;
                        channel_groups_names.push_back( std::string() );
                        channel_groups_numbers.push_back( std::vector<int>() );
                    }
                }
                catch ( const bad_lexical_cast & )
                {
                    esyslog("Live: could not convert '%s' into a channel number", thisChannel.c_str());
                    continue;
                }
            }
        }
    }

	if ( channel < 0 )
	{
		if (cDevice::CurrentChannel())
		{
            // find group corresponding to current channel
            int curGroup =0;
			int curChannel = cDevice::CurrentChannel();
            for ( std::vector< std::vector<int> >::iterator grIt = channel_groups_numbers.begin();
                  grIt != channel_groups_numbers.end() && channel < 0; ++grIt, ++curGroup )
            {
                for ( std::vector<int>::iterator chIt = (*grIt).begin();
                       chIt != (*grIt).end() && channel < 0; ++ chIt )
                {
                    if ( *chIt == curChannel )
                        channel_group = channel = curGroup;
                }
            }
            // if nothing is found, fall back to group 0
            if ( channel < 0 )
                channel = 0;
		}
		else
		{
            channel_group = channel;
		}
	}

	if ( channel >= (int)channel_groups_numbers.size() )
		channel = 0;
	channel_group = channel;
	{
		// build time list
		times_names.clear();
		times_start.clear();

		// calculate time of midnight (localtime) and convert back to GMT
		time_t now = (time(NULL)/3600)*3600;
		time_t now_local = time(NULL);
		struct tm tm_r;
		if ( localtime_r( &now_local, &tm_r ) == 0 ) {
			ostringstream builder;
			builder << "cannot represent timestamp " << now_local << " as local time";
			throw runtime_error( builder.str() );
		}
		tm_r.tm_hour=0;
		tm_r.tm_min=0;
		tm_r.tm_sec=0;
		time_t midnight = mktime( &tm_r );

		// add four 8h steps per day to the time list
		for (int i=0; i<4*MAX_DAYS ; i++ )
		{
			times_start.push_back( midnight + MAX_HOURS*3600*i );
		}
		vector< string > parts = StringSplit( LiveSetup().GetTimes(), ';' );
		vector< time_t > offsets;
		vector< string >::const_iterator part = parts.begin();
		for ( ; part != parts.end(); ++part )
		{
			try {
				unsigned int sep = (*part).find(':');
				std::string hour = (*part).substr(0, sep );
				if ( sep == (*part).npos )
				{
					esyslog("Live: Error parsing time '%s'", (*part).c_str() );
					continue;
				}
				std::string min = (*part).substr(sep+1, (*part).npos );
				offsets.push_back( lexical_cast<time_t>( hour )*60*60 + lexical_cast<time_t>( min ) *60 );
			}
			catch ( const bad_lexical_cast & ) {
				esyslog("Live: Error parsing time '%s'", part->c_str() );
			};
		};
		// add the time of the favourites to the time list
		for (int i=0; i< MAX_DAYS ; i++ )
		{
			vector< time_t >::const_iterator offset = offsets.begin();
			for ( ; offset != offsets.end(); ++offset )
			{
				times_start.push_back( midnight + 24*3600*i + *offset );
			}
		}
		// add now
		times_start.push_back( now );
		// sort the times
		std::sort( times_start.begin(), times_start.end() );
		// delete every time which has already passed
		while ( *times_start.begin()< now )
			times_start.erase(times_start.begin() );

		// build the corresponding names
		for ( vector< time_t >::const_iterator start = times_start.begin();
			  start != times_start.end(); ++start )
		{
			times_names.push_back(FormatDateTime( tr("%A, %x"), *start)
								  +std::string(" ")+ FormatDateTime( tr("%I:%M %p"), *start) );
		}
		// the first time is now
		times_names[0]=tr("Now");

		if ( time_para >= times_names.size() )
			time_para = times_names.size()-1;
		time_selected=time_para;
	}

  // <& pageelems.doc_type ...
  { 
#line 253 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 253 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR Live - 
#line 256 "multischedule.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 257 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 257 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 258 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 258 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 261 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 261 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 262 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 262 "multischedule.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("multischedule"), reply.out().getloc() ) );
#line 262 "multischedule.ecpp"
    _tnt_cq4.add( "component", tnt::toString(("multischedule.channel_selection"), reply.out().getloc() ) );
#line 262 "multischedule.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n
#line 264 "multischedule.ecpp"

	cSchedulesLock schedulesLock;
	cSchedules const* schedules = cSchedules::Schedules( schedulesLock );

	time_t now = time(NULL);
	if ( time_para >= times_start.size() )
	    time_para = times_start.size()-1;
	time_t sched_start = (times_start[ time_para ]/300)*300;
	time_t max_hours;
	try {
		max_hours = lexical_cast<time_t>( LiveSetup().GetScheduleDuration() );
	}
	catch ( const bad_lexical_cast & )
	{
		esyslog("Live: could not convert '%s' into a schedule duration", LiveSetup().GetScheduleDuration().c_str());
		max_hours = 8;
	};
	if (max_hours > 48)
	    max_hours = 48;

	time_t sched_end = sched_start + 60 * 60 * max_hours;
	int sched_end_row = ( sched_end - sched_start ) / 60 / MINUTES_PER_ROW;
	std::list<SchedEntry> table[MAX_CHANNELS];
	std::vector<std::string> channel_names(channel_groups_numbers[ channel ].size() );
	std::vector<tChannelID> channel_IDs(channel_groups_numbers[ channel ].size() );
	if ( channel >= (int)channel_groups_numbers.size() )
		channel = channel_groups_numbers.size()-1;
	//for ( int chan = 0; chan<MAX_CHANNELS; chan++)
	for ( unsigned int j = 0; j<channel_groups_numbers[ channel ].size(); j++)
	{
		int prev_row = -1;


		int chan = channel_groups_numbers[ channel ][ j ];

		cChannel* Channel = Channels.GetByNumber( chan );
		if ( ! Channel )
			continue;
		if ( Channel->GroupSep() || Channel->Name() == '\0' )
			continue;
		channel_names[ j ] = Channel->Name();
		channel_IDs[ j ] = Channel->GetChannelID();

		cSchedule const* Schedule = schedules->GetSchedule( Channel );
		if ( ! Schedule )
			continue;
		for (const cEvent *Event = Schedule->Events()->First(); Event;
			 Event = Schedule->Events()->Next(Event) )
		{
			if (Event->EndTime() <= sched_start )
				continue;
			if (Event->StartTime() >= sched_end )
				continue;

			EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(Channel, Event);
			if ( prev_row < 0 && Event->StartTime() > sched_start + MINUTES_PER_ROW )
			{
				// insert dummy event at start
				table[ j ].push_back( SchedEntry() );
				SchedEntry &en=table[ j ].back();
				int event_start_row = (Event->StartTime() - sched_start) / 60 / MINUTES_PER_ROW;
				en.start_row = 0;
				en.row_count = event_start_row;
				// no title and no start time = dummy event
				en.title = "";
				en.start = "";
				prev_row = en.start_row + en.row_count;
			}
			table[ j ].push_back( SchedEntry() );
			SchedEntry &en=table[j].back();

			en.title = epgEvent->Title();
			en.short_description = epgEvent->ShortDescr();
			en.description = epgEvent->LongDescr();
			en.start = epgEvent->StartTime(tr("%I:%M %p"));
			en.end = epgEvent->EndTime(tr("%I:%M %p"));
			en.day = epgEvent->StartTime(tr("%A, %b %d %Y"));
			en.epgid = EpgEvents::EncodeDomId(Channel->GetChannelID(), Event->EventID());
			en.has_timer = LiveTimerManager().GetTimer(Event->EventID(), Channel->GetChannelID() ) != 0;

			en.start_row = prev_row > 0 ? prev_row : 0;
			int end_time = Schedule->Events()->Next(Event) ?
				Schedule->Events()->Next(Event)->StartTime() :
				Event->EndTime();
			if (end_time > sched_end)
				end_time = sched_end;
			int next_event_start_row = (end_time - sched_start) / 60 / MINUTES_PER_ROW;
			en.row_count = next_event_start_row - en.start_row;
			if ( en.row_count < 1 )
				en.row_count = 1;
			prev_row = en.start_row + en.row_count;

			// truncate description if too long
			en.truncated=false;
			en.description_trunc=StringWordTruncate( en.description,
													 CHARACTERS_PER_ROW*(en.row_count-2),
													 en.truncated );



		};
		if ( table[ j ].begin() == table[ j ].end() )
		{
			// no entries... create a single dummy entry
			table[ j ].push_back( SchedEntry() );
			SchedEntry &en=table[ j ].back();
			en.start_row = 0;
			en.row_count = sched_end_row;
			// no title and no start time = dummy event
			en.title = "";
			en.start = "";
		}
	}

  reply.out() << data[6]; // \t\t<table class="mschedule" cellspacing="0" cellpadding="0">\n
#line 379 "multischedule.ecpp"


  reply.out() << data[7]; // \t       <tr class=" topaligned ">\n\t       <td > <div class="boxheader"> <div><div>
#line 382 "multischedule.ecpp"
  reply.sout() << ( tr("Time") );
  reply.out() << data[8]; // </div></div> </div></td>\n\t       <td class="time spacer"> &nbsp; </td>\n
#line 384 "multischedule.ecpp"

                for ( unsigned int channel = 0; channel< channel_names.size() ; channel++)
                {

  reply.out() << data[9]; // \t       <td> <div class="boxheader"> <div> <div>
#line 388 "multischedule.ecpp"
  reply.sout() << ( channel_names[channel] );
  reply.out() << data[10]; //  
  reply.out() << data[11]; // \n            
  // <& pageelems.ajax_action_href ...
  { 
#line 389 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 389 "multischedule.ecpp"
    _tnt_cq5.add( "action", tnt::toString("switch_channel", reply.out().getloc() ) );
#line 389 "multischedule.ecpp"
    _tnt_cq5.add( "alt", tnt::toString("", reply.out().getloc() ) );
#line 389 "multischedule.ecpp"
    _tnt_cq5.add( "image", tnt::toString("zap.png", reply.out().getloc() ) );
#line 389 "multischedule.ecpp"
    _tnt_cq5.add( "param", tnt::toString((channel_IDs[channel]), reply.out().getloc() ) );
#line 389 "multischedule.ecpp"
    _tnt_cq5.add( "tip", tnt::toString((tr("Switch to this channel.")), reply.out().getloc() ) );
#line 389 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[12]; // \n            
  // <& pageelems.vlc_stream_channel ...
  { 
#line 390 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 390 "multischedule.ecpp"
    _tnt_cq6.add( "channelId", tnt::toString((channel_IDs[channel]), reply.out().getloc() ) );
#line 390 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "vlc_stream_channel"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << data[13]; // \n            </div></div> </div></td>\n\t       <td class="time spacer"> &nbsp; </td>\n
#line 393 "multischedule.ecpp"

                }

  reply.out() << data[14]; // \t       </tr>\n
#line 397 "multischedule.ecpp"

                bool odd=true;
                std::list<SchedEntry>::iterator  cur_event[ MAX_CHANNELS ];
                for (int i=0;i<MAX_CHANNELS;i++)
                        cur_event[i]=table[i].begin();
                for (int row = 0 ; row < sched_end_row; row++ )
		{
                       int minutes= ( (sched_start +  row * 60 * MINUTES_PER_ROW ) % 3600 ) / 60;
                       string row_class;
                       if ( minutes < MINUTES_PER_ROW )
                       {
                         // full hour, swap odd/even
                         odd = !odd;
                       };
                       if (  (sched_start +  row * 60 * MINUTES_PER_ROW ) <= now &&
                             (sched_start +  (row+1) * 60 * MINUTES_PER_ROW ) > now )
                       {
                         row_class +=" current_row ";
                       }
                       row_class += odd ? " odd " : " even ";


  reply.out() << data[15]; // \t\t       <tr>\n\t\t       <td class=" time leftcol rightcol 
#line 420 "multischedule.ecpp"
  reply.sout() << ( row_class );
  reply.out() << data[16]; // ">\n
#line 421 "multischedule.ecpp"

			if (  minutes < MINUTES_PER_ROW )
			{

  reply.out() << data[17]; // \t\t       
#line 425 "multischedule.ecpp"
  reply.sout() << ( FormatDateTime( tr("%I:%M %p"), sched_start +  row * 60 * MINUTES_PER_ROW )  );
  reply.out() << data[18]; // \n
#line 426 "multischedule.ecpp"

			}
			else
			{

  reply.out() << data[19]; // \t\t\t &nbsp;\n
#line 432 "multischedule.ecpp"

		        }

  reply.out() << data[20]; // \t\t       </td>\n
#line 436 "multischedule.ecpp"

                        for ( unsigned int channel = 0; channel< channel_names.size() ; channel++)
                        {
                                // output spacer column

  reply.out() << data[21]; // \t\t                <td class = " time spacer " > &nbsp; </td>\n
#line 442 "multischedule.ecpp"

                                if ( cur_event[channel] == table[channel].end()
                                     || cur_event[channel]->start_row != row )
                                  // no new event in this channel, skip it
                                  continue;

                                SchedEntry &en=*cur_event[channel];
                                if (en.title.empty() && en.start.empty() )
                                {
                                  // empty dummy event

  reply.out() << data[22]; // \t\t\t<td class="event topaligned leftcol rightcol" rowspan="
#line 453 "multischedule.ecpp"
  reply.sout() << ( en.row_count );
  reply.out() << data[23]; // ">\n                        </td>\n
#line 455 "multischedule.ecpp"

				  ++cur_event[channel];
                                  continue;

                                }
                                // output an event cell

  reply.out() << data[24]; // \t\t\t<td class="event topaligned leftcol rightcol 
#line 462 "multischedule.ecpp"
  reply.sout() << ( en.has_timer ? "has_timer" : "" );
  reply.out() << data[25]; // " rowspan="
#line 462 "multischedule.ecpp"
  reply.sout() << ( en.row_count );
  reply.out() << data[26]; // ">\n                        <div class=" content1 " >\n                        <div class=" tools1 " >\n                          
  // <& pageelems.event_timer ...
  { 
#line 465 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 465 "multischedule.ecpp"
    _tnt_cq7.add( "epgid", tnt::toString((en.epgid), reply.out().getloc() ) );
#line 465 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[27]; // \n
#line 466 "multischedule.ecpp"

                           if (LiveFeatures<features::epgsearch>().Recent() ) {

  reply.out() << data[28]; //                           <a href="searchresults.html\?searchplain=
#line 469 "multischedule.ecpp"
  reply.sout() << ( StringUrlEncode(en.title) );
  reply.out() << data[29]; // "><img src="
#line 469 "multischedule.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << data[30]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 469 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 469 "multischedule.ecpp"
    _tnt_cq8.add( "text", tnt::toString((tr("Search for repeats.")), reply.out().getloc() ) );
#line 469 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << data[31]; // ></img></a>\n
#line 470 "multischedule.ecpp"

                           } else {
                             
  reply.out() << data[32]; // <img src="img/transparent.png" width="16" height="16">
#line 472 "multischedule.ecpp"

                           }

  reply.out() << data[33]; //                           
  // <& pageelems.imdb_info_href ...
  { 
#line 475 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 475 "multischedule.ecpp"
    _tnt_cq9.add( "title", tnt::toString((en.title), reply.out().getloc() ) );
#line 475 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << data[34]; // \n                         </div><div class= "start withmargin">
#line 476 "multischedule.ecpp"
  reply.sout() << ( en.start );
  reply.out() << data[35]; // </div>\n\t\t\t  <div class="title withmargin"><a 
  // <& tooltip.hint ...
  { 
#line 477 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 477 "multischedule.ecpp"
    _tnt_cq10.add( "text", tnt::toString((StringEscapeAndBreak(tr("Click to view details."))), reply.out().getloc() ) );
#line 477 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 477 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 477 "multischedule.ecpp"
    _tnt_cq11.add( "domId", tnt::toString(en.epgid, reply.out().getloc() ) );
#line 477 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << data[36]; // >
#line 477 "multischedule.ecpp"
  reply.sout() << ( en.title );
  reply.out() << data[37]; // </a></div>\n
#line 478 "multischedule.ecpp"

                         if ( en.row_count>2 && !en.short_description.empty() )
                         {

  reply.out() << data[38]; //                           <div class="short withmargin">
#line 482 "multischedule.ecpp"
  reply.sout() << ( en.short_description.empty() ? "&nbsp;" : en.short_description );
  reply.out() << data[39]; // </div>\n
#line 483 "multischedule.ecpp"

                         }
                         if ( en.row_count>3 && ! en.description_trunc.empty() )
                         {

  reply.out() << data[40]; //                           <div class="description withmargin">
#line 488 "multischedule.ecpp"
  reply.sout() << (en.description_trunc);
  reply.out() << data[41]; // ...\n
#line 489 "multischedule.ecpp"

                           if ( en.truncated )
                           {

  reply.out() << data[42]; //                            <a 
  // <& tooltip.hint ...
  { 
#line 493 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 493 "multischedule.ecpp"
    _tnt_cq12.add( "text", tnt::toString((StringEscapeAndBreak(tr("Click to view details."))), reply.out().getloc() ) );
#line 493 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 493 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 493 "multischedule.ecpp"
    _tnt_cq13.add( "domId", tnt::toString(en.epgid, reply.out().getloc() ) );
#line 493 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << data[43]; // > 
#line 493 "multischedule.ecpp"
  reply.sout() << ( tr("more") );
  reply.out() << data[44]; // </a>\n
#line 494 "multischedule.ecpp"

                           }

  reply.out() << data[45]; //                            </div>\n
#line 498 "multischedule.ecpp"

                         }

  reply.out() << data[46]; //                           </div></div>\n                          </td>\n
#line 503 "multischedule.ecpp"

                          // move to next event for this channel
                          ++cur_event[channel];
                        }

  reply.out() << data[47]; // \t\t       </tr>\n
#line 509 "multischedule.ecpp"

		}

  reply.out() << data[48]; // \t\t\t<tr>\n
#line 513 "multischedule.ecpp"

			for ( unsigned int channel = 0; channel <= channel_names.size() ; channel++)
			{

  reply.out() << data[49]; // \t\t\t<td class = " event leftcol rightcol bottomrow " > &nbsp; </td>\n\t\t\t<td class = " time spacer " > &nbsp; </td>\n
#line 519 "multischedule.ecpp"

			}

  reply.out() << data[50]; // \t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[51]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[52]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::channel_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("multischedule::channel_selection " << qparam.getUrl());
  tnt::DataChunks data(rawData);
#line 48 "multischedule.ecpp"
  typedef unsigned int channel_group_type;
  TNT_REQUEST_PAGE_VAR(channel_group_type, channel_group, "unsigned int channel_group", (0));   // <%request> unsigned int channel_group(0)
#line 49 "multischedule.ecpp"
  typedef unsigned int time_selected_type;
  TNT_REQUEST_PAGE_VAR(time_selected_type, time_selected, "unsigned int time_selected", (0));   // <%request> unsigned int time_selected(0)
#line 45 "multischedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[53]; // <form action="multischedule.html" method="get" id="channels">\n   <span>\n     <label for="channel">
#line 532 "multischedule.ecpp"
  reply.sout() << ( tr("Channel") );
  reply.out() << data[54]; // :&nbsp;<span class="bold"></span></label>\n     <select name="channel" id="channel"  onchange="document.forms.channels.submit()" >\n
#line 534 "multischedule.ecpp"
	for ( unsigned int i = 0; i < channel_groups_names.size(); ++i ) {

#line 535 "multischedule.ecpp"


  reply.out() << data[55]; // \t\t<option value="
#line 536 "multischedule.ecpp"
  reply.sout() << ( i );
  reply.out() << data[56]; // "\n
#line 537 "multischedule.ecpp"
                      if ( i == channel_group )

#line 538 "multischedule.ecpp"
                      {

  reply.out() << data[57]; // \t\t\tselected="selected"\n
#line 540 "multischedule.ecpp"
                      }

  reply.out() << data[58]; //                         >
#line 541 "multischedule.ecpp"
  reply.sout() << ( channel_groups_names[i] );
  reply.out() << data[59]; // </option>\n
#line 542 "multischedule.ecpp"
	}

  reply.out() << data[60]; //      </select>\n     <label for="time_para">
#line 544 "multischedule.ecpp"
  reply.sout() << ( tr("Time") );
  reply.out() << data[61]; // :&nbsp;<span class="bold"></span></label>\n     <select name="time_para" id="time_para"  onchange="document.forms.channels.submit()" >\n
#line 546 "multischedule.ecpp"
	for ( unsigned int i = 0; i < times_names.size(); ++i ) {

#line 547 "multischedule.ecpp"


  reply.out() << data[62]; // \t\t<option value="
#line 548 "multischedule.ecpp"
  reply.sout() << ( i );
  reply.out() << data[63]; // "\n
#line 549 "multischedule.ecpp"
                      if ( i == time_selected )

#line 550 "multischedule.ecpp"
                      {

  reply.out() << data[64]; // \t\t\tselected="selected"\n
#line 552 "multischedule.ecpp"
                      }

  reply.out() << data[65]; //                         >
#line 553 "multischedule.ecpp"
  reply.sout() << ( times_names[i] );
  reply.out() << data[66]; // </option>\n
#line 554 "multischedule.ecpp"
	}

  reply.out() << data[67]; //      </select>\n
#line 556 "multischedule.ecpp"
 //     <& pageelems.ajax_action_href action="switch_channel" tip=(tr("Switch to this channel.")) param=(Channel->GetChannelID()) image="zap.png" alt="" &>

#line 557 "multischedule.ecpp"
 //     <& pageelems.vlc_stream_channel channelId=(Channel->GetChannelID()) &>

  reply.out() << data[68]; //    </span>\n</form>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
