////////////////////////////////////////////////////////////////////////
// rwd_recording.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.rwd_recording")

// <%pre>
#line 1 "rwd_recording.ecpp"

#include <string>
#include <vdr/recording.h>
#include "exception.h"
#include "setup.h"
#include "tasks.h"
#include "tools.h"

using namespace std;
using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("rwd_recording");

static const char* rawData = "\010\000\000\000\t\000\000\000\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("rwd_recording " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string param = tnt::stringTo<string>("param", "string", qparam.param("param"), reply.out().getloc());
  // </%args>

#line 17 "rwd_recording.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
  // <%cpp>
#line 19 "rwd_recording.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");
	reply.setContentType( "application/xml" );

	BackwardRecordingTask task( param );
	LiveTaskManager().Execute( task );

  // <& xmlresponse.ajax ...
  { 
#line 26 "rwd_recording.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 26 "rwd_recording.ecpp"
    _tnt_cq0.add( "error", tnt::toString((task.Error()), reply.out().getloc() ) );
#line 26 "rwd_recording.ecpp"
    _tnt_cq0.add( "name", tnt::toString(("rwd_recording"), reply.out().getloc() ) );
#line 26 "rwd_recording.ecpp"
    _tnt_cq0.add( "pname", tnt::toString(("recording"), reply.out().getloc() ) );
#line 26 "rwd_recording.ecpp"
    _tnt_cq0.add( "result", tnt::toString((task.Result()), reply.out().getloc() ) );
#line 26 "rwd_recording.ecpp"
    _tnt_cq0.add( "value", tnt::toString((param), reply.out().getloc() ) );
#line 26 "rwd_recording.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ajax"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
