////////////////////////////////////////////////////////////////////////
// setup.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.setup")

// <%pre>
#line 1 "setup.ecpp"

#include <sys/stat.h>
#include <vdr/tools.h>
#include "setup.h"
#include "tools.h"
#include "users.h"
#include "i18n.h"

using namespace vdrlive;
using namespace std;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("setup");

static const char* rawData = "\034\001\000\000@\001\000\000K\001\000\000N\001\000\000\377\004\000\000\002\005\000\000y"
  "\005\000\000\275\005\000\000z\006\000\000\337\006\000\000L\007\000\000,\010\000\000l\010\000\000\354\010\000\0000\t"
  "\000\000\304\t\000\000-\n\000\000u\n\000\000\025\013\000\000\204\013\000\000\340\013\000\000M\014\000\000-\015\000"
  "\000\213\015\000\000\027\016\000\000\216\016\000\000x\017\000\000\323\017\000\000(\020\000\000\227\020\000\000\301"
  "\020\000\000\353\020\000\000\024\021\000\000>\021\000\000\347\021\000\000V\022\000\000\262\022\000\000\007\023\000"
  "\000o\023\000\000\276\023\000\000\325\023\000\000(\024\000\000\177\024\000\000\236\024\000\000\361\024\000\000K\025"
  "\000\000\300\025\000\000K\026\000\000\250\026\000\000(\027\000\000)\027\000\000V\027\000\000W\027\000\000\201\027\000"
  "\000\202\027\000\000\261\027\000\000\262\027\000\000\336\027\000\000\337\027\000\000\007\030\000\000\010\030\000\000t"
  "\030\000\000\306\030\000\000\334\030\000\000\336\030\000\000\337\030\000\000\351\030\000\000\261\031\000\000\023\032"
  "\000\000\024\032\000\000\025\032\000\000\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t\t<script t"
  "ype=\"text/javascript\"><!--\n\t\tfunction initform()\n\t\t{\n\t\t\tchangeduseauth(document.getElementById(\"useauth"
  "\"));\n\t\t\tchangeduseajax(document.getElementById(\"useAjax\"));\n\t\t\tchangedusestreamdev(document.getElementById"
  "(\"useStreamdev\"));\n\t\t\tif (document.getElementById(\"message\").value != \"\")\n\t\t\t\talert(document.getElemen"
  "tById(\"message\").value);\n\t\t}\n\t\tfunction changeduseauth(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"aut"
  "hsection\").style.display = (selection.checked \? \"block\" : \"none\");\n\t\t}\n\t\tfunction setauthchanged(selectio"
  "n)\n\t\t{\n\t\t\tdocument.getElementById(\"authchanged\").value = 1;\n\t\t}\n\t\tfunction changeduseajax(selection)\n"
  "\t\t{\n\t\t\tdocument.getElementById(\"ajaxsection\").style.display = (selection.checked \? \"block\" : \"none\");\n"
  "\t\t}\n\t\tfunction changedusestreamdev(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"streamdevsection\").style."
  "display = (selection.checked \? \"block\" : \"none\");\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload=\"initfo"
  "rm()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<form method=\"post\" action=\"setup.html\">\n\t\t\t\t<input t"
  "ype=\"hidden\" name=\"authchanged\" value=\"\" id=\"authchanged\"/>\n\t\t\t\t<input type=\"hidden\" name=\"message\" "
  "value=\"\" id=\"message\"/>\n\t\t\t\t<table class=\"formular\" cellpadding=\"0\" cellspacing=\"0\">\n\t\t\t\t\t<tr cl"
  "ass=\"head\">\n\t\t\t\t\t\t<td  class=\"toprow leftcol rightcol\" colspan=\"2\"><div class=\"boxheader\"><div><div></"
  "div></div></div></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmarg"
  "in\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"useauth\" id=\""
  "useauth\" value=\"1\"  onclick=\"changeduseauth(this)\"/>\n\t\t\t\t\t\t\t<div id=\"authsection\" style=\"display: non"
  "e\">\n\t\t\t\t\t\t\t<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"dependent\">\n\t\t\t\t\t\t\t<tr>"
  "\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text"
  "\" name=\"login\" value=\"\" id=\"login\" onchange=\"setauthchanged(this)\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t"
  "\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input  typ"
  "e=\"password\" name=\"pass\" value=\"\" id=\"pass\" onchange=\"setauthchanged(this)\" /></td>\n\t\t\t\t\t\t\t</tr>\n"
  "\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\"><a href=\"users.html\"></a></div></"
  "td>\n\t\t\t\t\t\t\t\t<td/>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class="
  "\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input  type=\"text\" name=\"localnetmask\" value=\"\" id=\"localnet"
  "mask\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>"
  "\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td cla"
  "ss=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"showLogo\" id=\"showLogo\" value=\"1\" />\n\t\t\t\t\t"
  "\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></"
  "td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"useAjax\" id=\"useAjax\" valu"
  "e=\"1\"  onclick=\"changeduseajax(this)\"/>\n\t\t\t\t\t\t\t<div id=\"ajaxsection\" style=\"display: none\">\n\t\t\t\t"
  "\t\t\t<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"dependent\">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t"
  "\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"checkbox\" name=\"s"
  "howInfoBox\" id=\"showInfoBox\" value=\"1\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div"
  ">\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargi"
  "n\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"useStreamdev\" i"
  "d=\"useStreamdev\" value=\"1\"  onclick=\"changedusestreamdev(this)\"/>\n\t\t\t\t\t\t\t<div id=\"streamdevsection\" s"
  "tyle=\"display: none\">\n\t\t\t\t\t\t\t<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"dependent\">\n"
  "\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><"
  "input type=\"text\" name=\"streamdevport\" id=\"streamdevport\" value=\"\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t"
  "\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><select name="
  "\"streamdevtype\" size=\"1\" id=\"streamdevtype\">\n\t\t\t\t\t\t\t\t\t<option value=\"TS\" >TS</option>\n\t\t\t\t\t\t"
  "\t\t\t<option value=\"PES\" >PES</option>\n\t\t\t\t\t\t\t\t\t<option value=\"PS\" >PS</option>\n\t\t\t\t\t\t\t\t\t<op"
  "tion value=\"ES\" >ES</option>\n\t\t\t\t\t\t\t\t\t<option value=\"EXT\" >EXT</option>\n\t\t\t\t\t\t\t\t</select></td>"
  "\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<t"
  "r>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol"
  "\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"showIMDb\" id=\"showIMDb\" value=\"1\" />\n\t\t\t\t\t\t</td>\n\t\t"
  "\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t"
  "\t\t<td class=\"rightcol\"><input type=\"text\" name=\"lastchannel\" value=\"\" id=\"lastchannel\" /></td>\n\t\t\t\t"
  "\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t"
  "<td class=\"rightcol\"><input type=\"text\" name=\"times\" value=\"\" id=\"times\" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t"
  "\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t"
  "<td class=\"rightcol\"><input type=\"text\" name=\"channelGroups\" value=\"\" id=\"channelGroups\" />\n\t\t\t\t\t\t\t"
  "</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td"
  ">\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"scheduleDuration\" value=\"\" id=\"scheduleDuration"
  "\" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"wit"
  "hmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"showChanne"
  "lsWithoutEPG\" id=\"showChannelsWithoutEPG\" value=\"1\" />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t"
  "\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><sel"
  "ect name=\"startscreen\" size=\"1\" id=\"startscreen\">\n\t\t\t\t\t\t\t<option value=\"whatsonnow\" ></option>\n\t\t"
  "\t\t\t\t\t<option value=\"whatsonnext\" ></option>\n\t\t\t\t\t\t\t<option value=\"schedule\" ></option>\n\t\t\t\t\t\t"
  "\t<option value=\"multischedule\" ></option>\n\t\t\t\t\t\t\t<option value=\"recordings\" ></option>\n\t\t\t\t\t\t\t<o"
  "ption value=\"timers\" ></option>\n\t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class"
  "=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><select name=\"theme\" "
  "size=\"1\" id=\"theme\">\n\t\t\t\t\t\t\t<option value=\"\" ></option>\n\t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n"
  "\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"buttonpanel leftcol rightcol bottomrow\" colspan=\"2\">\n\t\t\t\t\t\t\t<div c"
  "lass=\"withmargin\">\n\t\t\t\t\t\t\t<button class=\"green\" type=\"submit\" name=\"save\" ></button>\n\t\t\t\t\t\t\t<"
  "/div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("setup " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string lastchannel = tnt::stringTo<string>("lastchannel", "string", qparam.param("lastchannel"), reply.out().getloc());
bool useauth = qparam.has("useauth") ? tnt::stringToWithDefault<bool>(qparam.param("useauth"), ( false), reply.out().getloc()) : ( false);
string login = tnt::stringTo<string>("login", "string", qparam.param("login"), reply.out().getloc());
string pass = tnt::stringTo<string>("pass", "string", qparam.param("pass"), reply.out().getloc());
string times = tnt::stringTo<string>("times", "string", qparam.param("times"), reply.out().getloc());
string channelGroups = tnt::stringTo<string>("channelGroups", "string", qparam.param("channelGroups"), reply.out().getloc());
string scheduleDuration = tnt::stringTo<string>("scheduleDuration", "string", qparam.param("scheduleDuration"), reply.out().getloc());
string startscreen = tnt::stringTo<string>("startscreen", "string", qparam.param("startscreen"), reply.out().getloc());
string theme = tnt::stringTo<string>("theme", "string", qparam.param("theme"), reply.out().getloc());
string localnetmask = tnt::stringTo<string>("localnetmask", "string", qparam.param("localnetmask"), reply.out().getloc());
string showLogo = tnt::stringTo<string>("showLogo", "string", qparam.param("showLogo"), reply.out().getloc());
string useAjax = tnt::stringTo<string>("useAjax", "string", qparam.param("useAjax"), reply.out().getloc());
string showInfoBox = tnt::stringTo<string>("showInfoBox", "string", qparam.param("showInfoBox"), reply.out().getloc());
string useStreamdev = tnt::stringTo<string>("useStreamdev", "string", qparam.param("useStreamdev"), reply.out().getloc());
string showIMDb = tnt::stringTo<string>("showIMDb", "string", qparam.param("showIMDb"), reply.out().getloc());
string showChannelsWithoutEPG = tnt::stringTo<string>("showChannelsWithoutEPG", "string", qparam.param("showChannelsWithoutEPG"), reply.out().getloc());
string streamdevport = tnt::stringTo<string>("streamdevport", "string", qparam.param("streamdevport"), reply.out().getloc());
string streamdevtype = tnt::stringTo<string>("streamdevtype", "string", qparam.param("streamdevtype"), reply.out().getloc());
int authchanged = qparam.has("authchanged") ? tnt::stringToWithDefault<int>(qparam.param("authchanged"), ( 0), reply.out().getloc()) : ( 0);
  // </%args>

#line 35 "setup.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 38 "setup.ecpp"

if (!logged_in && LiveSetup().UseAuth() ) return reply.redirect("login.html");
if (!cUser::CurrentUserHasRightTo(UR_EDITSETUP))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

#define SELECTIF(x) reply.out() << ( (x) ? "selected=\"selected\"" : "" );
#define CHECKIF(x) reply.out() << ( (x) ? "checked=\"checked\"" : "" );

	std::string message;

	if ( request.getMethod() == "POST") {
		if (authchanged && useauth && (login.empty() || pass.empty()))
			message = tr("Please set login and password!");
		else
		{
			LiveSetup().SetLastChannel(lastchannel != "" ? lexical_cast< int >(lastchannel):0);
			LiveSetup().SetUseAuth(useauth);
			if (useauth) {
				LiveSetup().SetAdminLogin(login);
				if (pass != "")
					LiveSetup().SetAdminPassword(pass);
				LiveSetup().SetLocalNetMask(localnetmask);
				LiveSetup().CheckLocalNet(request.getPeerIp());
			}
			LiveSetup().SetTimes(times);
			LiveSetup().SetChannelGroups(channelGroups);
			LiveSetup().SetScheduleDuration(scheduleDuration);
			LiveSetup().SetStartScreen(startscreen);
			LiveSetup().SetTheme(theme);
			LiveSetup().SetShowLogo(!showLogo.empty());
			LiveSetup().SetUseAjax(!useAjax.empty());
			if (LiveSetup().GetUseAjax()) {
				LiveSetup().SetShowInfoBox(!showInfoBox.empty());
			}
			LiveSetup().SetUseStreamdev(!useStreamdev.empty());
			LiveSetup().SetStreamdevPort(streamdevport.empty() ? 3000 : lexical_cast<int>(streamdevport));
			LiveSetup().SetStreamdevType(streamdevtype.empty() ? "PES" : streamdevtype);
			LiveSetup().SetShowIMDb(!showIMDb.empty());
			LiveSetup().SetShowChannelsWithoutEPG(!showChannelsWithoutEPG.empty());
			LiveSetup().SaveSetup();

			message = tr("Setup saved.");
		}
	}
	pageTitle = tr("Setup");
	int ilastchannel = LiveSetup().GetLastChannel();
	if (ilastchannel == std::numeric_limits< int >::max())
		lastchannel = "";
	else
		lastchannel = lexical_cast<std::string, int>(ilastchannel);

	login = LiveSetup().GetAdminLogin();
	useauth = LiveSetup().GetUseAuth();
	times = LiveSetup().GetTimes();
	channelGroups = LiveSetup().GetChannelGroups();
	scheduleDuration = LiveSetup().GetScheduleDuration();
	startscreen = LiveSetup().GetStartScreen();
	theme = LiveSetup().GetTheme();
	localnetmask = LiveSetup().GetLocalNetMask();
	showLogo = LiveSetup().GetShowLogo() ? "1" : "";
	useAjax = LiveSetup().GetUseAjax() ? "1" : "";
	showInfoBox = LiveSetup().GetShowInfoBox() ? "1" : "";
	useStreamdev = LiveSetup().GetUseStreamdev() ? "1" : "";
	streamdevport = lexical_cast<std::string, int>(LiveSetup().GetStreamdevPort());
	streamdevtype = LiveSetup().GetStreamdevType();
	showIMDb = LiveSetup().GetShowIMDb() ? "1" : "";
	showChannelsWithoutEPG = LiveSetup().GetShowChannelsWithoutEPG() ? "1" : "";

  // <& pageelems.doc_type ...
  { 
#line 106 "setup.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 106 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 109 "setup.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 110 "setup.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 110 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 111 "setup.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 111 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t\t<script type="text/javascript"><!--\n\t\tfunction initform()\n\t\t{\n\t\t\tchangeduseauth(document.getElementById("useauth"));\n\t\t\tchangeduseajax(document.getElementById("useAjax"));\n\t\t\tchangedusestreamdev(document.getElementById("useStreamdev"));\n\t\t\tif (document.getElementById("message").value != "")\n\t\t\t\talert(document.getElementById("message").value);\n\t\t}\n\t\tfunction changeduseauth(selection)\n\t\t{\n\t\t\tdocument.getElementById("authsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\tfunction setauthchanged(selection)\n\t\t{\n\t\t\tdocument.getElementById("authchanged").value = 1;\n\t\t}\n\t\tfunction changeduseajax(selection)\n\t\t{\n\t\t\tdocument.getElementById("ajaxsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\tfunction changedusestreamdev(selection)\n\t\t{\n\t\t\tdocument.getElementById("streamdevsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="initform()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 140 "setup.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 140 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 141 "setup.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 141 "setup.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("setup"), reply.out().getloc() ) );
#line 141 "setup.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n\t\t\t<form method="post" action="setup.html">\n\t\t\t\t<input type="hidden" name="authchanged" value="
#line 144 "setup.ecpp"
  reply.sout() << ( authchanged );
  reply.out() << data[6]; // " id="authchanged"/>\n\t\t\t\t<input type="hidden" name="message" value="
#line 145 "setup.ecpp"
  reply.sout() << ( message );
  reply.out() << data[7]; // " id="message"/>\n\t\t\t\t<table class="formular" cellpadding="0" cellspacing="0">\n\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t<td  class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div><div>
#line 148 "setup.ecpp"
  reply.sout() << ( tr("Setup") );
  reply.out() << data[8]; // </div></div></div></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 151 "setup.ecpp"
  reply.sout() << ( tr("Use authentication") );
  reply.out() << data[9]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useauth" id="useauth" value="1" 
#line 153 "setup.ecpp"
 CHECKIF(useauth); 
  reply.out() << data[10]; //  onclick="changeduseauth(this)"/>\n\t\t\t\t\t\t\t<div id="authsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 157 "setup.ecpp"
  reply.sout() << ( tr("Admin login") );
  reply.out() << data[11]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="login" value="
#line 158 "setup.ecpp"
  reply.sout() << ( login );
  reply.out() << data[12]; // " id="login" onchange="setauthchanged(this)" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 161 "setup.ecpp"
  reply.sout() << ( tr("Admin password") );
  reply.out() << data[13]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input  type="password" name="pass" value="
#line 162 "setup.ecpp"
  reply.sout() << ( pass );
  reply.out() << data[14]; // " id="pass" onchange="setauthchanged(this)" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin"><a href="users.html">
#line 165 "setup.ecpp"
  reply.sout() << ( tr("User management") );
  reply.out() << data[15]; // </a></div></td>\n\t\t\t\t\t\t\t\t<td/>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 169 "setup.ecpp"
  reply.sout() << ( tr("Local net (no login required)") );
  reply.out() << data[16]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input  type="text" name="localnetmask" value="
#line 170 "setup.ecpp"
  reply.sout() << ( localnetmask );
  reply.out() << data[17]; // " id="localnetmask" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 177 "setup.ecpp"
  reply.sout() << ( tr("Show live logo image") );
  reply.out() << data[18]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showLogo" id="showLogo" value="1" 
#line 179 "setup.ecpp"
 CHECKIF(!showLogo.empty()); 
  reply.out() << data[19]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 183 "setup.ecpp"
  reply.sout() << ( tr("Use ajax technology") );
  reply.out() << data[20]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useAjax" id="useAjax" value="1" 
#line 185 "setup.ecpp"
 CHECKIF(!useAjax.empty()); 
  reply.out() << data[21]; //  onclick="changeduseajax(this)"/>\n\t\t\t\t\t\t\t<div id="ajaxsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 189 "setup.ecpp"
  reply.sout() << ( tr("Show dynamic VDR information box") );
  reply.out() << data[22]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="checkbox" name="showInfoBox" id="showInfoBox" value="1" 
#line 190 "setup.ecpp"
 CHECKIF(!showInfoBox.empty()); 
  reply.out() << data[23]; // /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 197 "setup.ecpp"
  reply.sout() << ( tr("Allow video streaming") );
  reply.out() << data[24]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useStreamdev" id="useStreamdev" value="1" 
#line 199 "setup.ecpp"
 CHECKIF(!useStreamdev.empty()); 
  reply.out() << data[25]; //  onclick="changedusestreamdev(this)"/>\n\t\t\t\t\t\t\t<div id="streamdevsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 203 "setup.ecpp"
  reply.sout() << ( tr("Streamdev server port") );
  reply.out() << data[26]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamdevport" id="streamdevport" value="
#line 204 "setup.ecpp"
  reply.sout() << ( streamdevport );
  reply.out() << data[27]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 207 "setup.ecpp"
  reply.sout() << ( tr("Streamdev stream type") );
  reply.out() << data[28]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><select name="streamdevtype" size="1" id="streamdevtype">\n\t\t\t\t\t\t\t\t\t<option value="TS" 
#line 209 "setup.ecpp"
 SELECTIF(streamdevtype == "TS") 
  reply.out() << data[29]; // >TS</option>\n\t\t\t\t\t\t\t\t\t<option value="PES" 
#line 210 "setup.ecpp"
 SELECTIF(streamdevtype == "PES") 
  reply.out() << data[30]; // >PES</option>\n\t\t\t\t\t\t\t\t\t<option value="PS" 
#line 211 "setup.ecpp"
 SELECTIF(streamdevtype == "PS") 
  reply.out() << data[31]; // >PS</option>\n\t\t\t\t\t\t\t\t\t<option value="ES" 
#line 212 "setup.ecpp"
 SELECTIF(streamdevtype == "ES") 
  reply.out() << data[32]; // >ES</option>\n\t\t\t\t\t\t\t\t\t<option value="EXT" 
#line 213 "setup.ecpp"
 SELECTIF(streamdevtype == "EXT") 
  reply.out() << data[33]; // >EXT</option>\n\t\t\t\t\t\t\t\t</select></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 221 "setup.ecpp"
  reply.sout() << ( tr("Add links to IMDb") );
  reply.out() << data[34]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showIMDb" id="showIMDb" value="1" 
#line 223 "setup.ecpp"
 CHECKIF(!showIMDb.empty()); 
  reply.out() << data[35]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 227 "setup.ecpp"
  reply.sout() << ( tr("Last channel to display") );
  reply.out() << data[36]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="lastchannel" value="
#line 228 "setup.ecpp"
  reply.sout() << ( lastchannel );
  reply.out() << data[37]; // " id="lastchannel" /></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 231 "setup.ecpp"
  reply.sout() << ( tr("Additional fixed times in 'What's on?'") );
  reply.out() << data[38]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="times" value="
#line 232 "setup.ecpp"
  reply.sout() << ( times );
  reply.out() << data[39]; // " id="times" />\n\t\t\t\t\t\t\t
  // <& tooltip.help ...
  { 
#line 233 "setup.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 233 "setup.ecpp"
    _tnt_cq5.add( "text", tnt::toString((tr("Format is HH:MM. Separate multiple times with a semicolon")), reply.out().getloc() ) );
#line 233 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[40]; // </td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 236 "setup.ecpp"
  reply.sout() << ( tr("Channel groups for MultiSchedule") );
  reply.out() << data[41]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="channelGroups" value="
#line 237 "setup.ecpp"
  reply.sout() << ( channelGroups );
  reply.out() << data[42]; // " id="channelGroups" />\n\t\t\t\t\t\t\t
  // <& tooltip.help ...
  { 
#line 238 "setup.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 238 "setup.ecpp"
    _tnt_cq6.add( "text", tnt::toString((tr("Separate channels with a comma ',', separate groups with a semi-colon ';'")), reply.out().getloc() ) );
#line 238 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << data[43]; // </td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 241 "setup.ecpp"
  reply.sout() << ( tr("Duration of MultiSchedule in hours") );
  reply.out() << data[44]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="scheduleDuration" value="
#line 242 "setup.ecpp"
  reply.sout() << ( scheduleDuration );
  reply.out() << data[45]; // " id="scheduleDuration" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 246 "setup.ecpp"
  reply.sout() << ( tr("Show channels without EPG") );
  reply.out() << data[46]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showChannelsWithoutEPG" id="showChannelsWithoutEPG" value="1" 
#line 248 "setup.ecpp"
 CHECKIF(!showChannelsWithoutEPG.empty()); 
  reply.out() << data[47]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 253 "setup.ecpp"
  reply.sout() << ( tr("Start page") );
  reply.out() << data[48]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="startscreen" size="1" id="startscreen">\n\t\t\t\t\t\t\t<option value="whatsonnow" 
#line 255 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnow") 
  reply.out() << data[49]; // >
#line 255 "setup.ecpp"
  reply.sout() << ( trVDR("What's on now?") );
  reply.out() << data[50]; // </option>\n\t\t\t\t\t\t\t<option value="whatsonnext" 
#line 256 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnext") 
  reply.out() << data[51]; // >
#line 256 "setup.ecpp"
  reply.sout() << ( trVDR("What's on next?") );
  reply.out() << data[52]; // </option>\n\t\t\t\t\t\t\t<option value="schedule" 
#line 257 "setup.ecpp"
 SELECTIF(startscreen == "schedule") 
  reply.out() << data[53]; // >
#line 257 "setup.ecpp"
  reply.sout() << ( trVDR("Schedule") );
  reply.out() << data[54]; // </option>\n\t\t\t\t\t\t\t<option value="multischedule" 
#line 258 "setup.ecpp"
 SELECTIF(startscreen == "multischedule") 
  reply.out() << data[55]; // >
#line 258 "setup.ecpp"
  reply.sout() << ( tr("MultiSchedule") );
  reply.out() << data[56]; // </option>\n\t\t\t\t\t\t\t<option value="recordings" 
#line 259 "setup.ecpp"
 SELECTIF(startscreen == "recordings") 
  reply.out() << data[57]; // >
#line 259 "setup.ecpp"
  reply.sout() << ( trVDR("Recordings") );
  reply.out() << data[58]; // </option>\n\t\t\t\t\t\t\t<option value="timers" 
#line 260 "setup.ecpp"
 SELECTIF(startscreen == "timers") 
  reply.out() << data[59]; // >
#line 260 "setup.ecpp"
  reply.sout() << ( trVDR("Timers") );
  reply.out() << data[60]; // </option>\n\t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 264 "setup.ecpp"
  reply.sout() << ( tr("Theme") );
  reply.out() << data[61]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="theme" size="1" id="theme">\n
#line 266 "setup.ecpp"

{
	const string dirPath(Plugin::GetResourceDirectory() + "/themes");
	cReadDir d(dirPath.c_str());
	struct dirent* e;
	string parent("..");
	string current(".");
	string cvsDir("CVS");
	while ((e = d.Next())) {
		if ((current == e->d_name) || (parent == e->d_name) || (cvsDir == e->d_name)) {
			continue;
		}
		/* Check if entry is a directory: I do not rely on e->d_type
		   here because on some systems it is allways DT_UNKNOWN. Also
		   testing for DT_DIR does not take into account symbolic
		   links to directories.
		*/
		struct stat buf;
		if ((stat((dirPath + "/" + e->d_name).c_str(), &buf) != 0) || (!S_ISDIR(buf.st_mode))) {
			continue;
		}

  reply.out() << data[62]; // \t\t\t\t\t\t\t<option value="
#line 288 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << data[63]; // " 
#line 288 "setup.ecpp"
 SELECTIF(theme == e->d_name) 
  reply.out() << data[64]; // >
#line 288 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << data[65]; // </option>\n
#line 289 "setup.ecpp"

	}
}

  reply.out() << data[66]; // \t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n\t\t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t\t<button class="green" type="submit" name="save" >
#line 298 "setup.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << data[67]; // </button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << data[68]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[69]; // \n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
