////////////////////////////////////////////////////////////////////////
// switch_channel.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.switch_channel")

// <%pre>
#line 1 "switch_channel.ecpp"

#include <vdr/channels.h>
#include "exception.h"
#include "tasks.h"
#include "tools.h"
#include "users.h"

using namespace std;
using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("switch_channel");

static const char* rawData = "\030\000\000\0005\000\000\000C\000\000\000P\000\000\000c\000\000\000d\000\000\000Normale "
  "Seite:<br/>\nchannel: <br/>\nresult: <br/>\nerror: <br />\nSeitenende!\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("switch_channel " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
tChannelID param = tnt::stringTo<tChannelID>("param", "tChannelID", qparam.param("param"), reply.out().getloc());
string async = tnt::stringTo<string>("async", "string", qparam.param("async"), reply.out().getloc());
  // </%args>

  // <%cpp>
#line 16 "switch_channel.ecpp"

	bool ajaxReq = !async.empty() && (lexical_cast<int>(async) != 0);
	string referrer;

	if (!cUser::CurrentUserHasRightTo(UR_SWITCHCHNL))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

	if (ajaxReq) {
		reply.setContentType( "application/xml" );
	}
	else {
		referrer = request.getHeader("Referer:");
	}

	SwitchChannelTask task( param );
	LiveTaskManager().Execute( task );

	if (!ajaxReq) {
		if (!referrer.empty()) {
			return reply.redirect(referrer);
		}

  reply.out() << data[0]; // Normale Seite:<br/>\nchannel: 
#line 39 "switch_channel.ecpp"
  reply.sout() << ( param );
  reply.out() << data[1]; // <br/>\nresult: 
#line 40 "switch_channel.ecpp"
  reply.sout() << ( (task.Result()) );
  reply.out() << data[2]; // <br/>\nerror: 
#line 41 "switch_channel.ecpp"
  reply.sout() << ( (task.Error()) );
  reply.out() << data[3]; // <br />\nSeitenende!\n
#line 43 "switch_channel.ecpp"

	}
	else {

  // <& xmlresponse.ajax ...
  { 
#line 47 "switch_channel.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 47 "switch_channel.ecpp"
    _tnt_cq0.add( "error", tnt::toString((task.Error()), reply.out().getloc() ) );
#line 47 "switch_channel.ecpp"
    _tnt_cq0.add( "name", tnt::toString(("switch_channel"), reply.out().getloc() ) );
#line 47 "switch_channel.ecpp"
    _tnt_cq0.add( "pname", tnt::toString(("channel"), reply.out().getloc() ) );
#line 47 "switch_channel.ecpp"
    _tnt_cq0.add( "result", tnt::toString((task.Result()), reply.out().getloc() ) );
#line 47 "switch_channel.ecpp"
    _tnt_cq0.add( "value", tnt::toString((param), reply.out().getloc() ) );
#line 47 "switch_channel.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ajax"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[4]; // \n
#line 48 "switch_channel.ecpp"

	}

  // <%/cpp>
  return HTTP_OK;
}

} // namespace
