////////////////////////////////////////////////////////////////////////
// tooltip.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.tooltip")

// <%pre>
#line 1 "tooltip.ecpp"

#include "setup.h"

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class hint_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hint_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class display_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        display_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class help_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        help_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    hint_type hint;
    display_type display;
    help_type help;
};

static tnt::ComponentFactoryImpl<_component_> Factory("tooltip");

static const char* rawData = "(\000\000\000/\000\000\0001\000\000\0002\000\000\000K\000\000\000M\000\000\000N\000\000"
  "\000X\000\000\000a\000\000\000i\000\000\000title=\"\"\n\nhref=\"epginfo.html\?epgid=\"\n\n<img src=\"\" alt=\"\" ></i"
  "mg>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    hint(*this, "hint"),
    display(*this, "display"),
    help(*this, "help")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("tooltip " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%cpp>
  reply.out() << data[2]; // \n
  reply.out() << data[5]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::hint_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("tooltip::hint " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
std::string text = qparam.param("text");
  // </%args>

  // <%cpp>
  reply.out() << data[0]; // title="
#line 11 "tooltip.ecpp"
  reply.sout() << ( text );
  reply.out() << data[1]; // "\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::display_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("tooltip::display " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
std::string domId = qparam.param("domId");
  // </%args>

  // <%cpp>
  reply.out() << data[3]; // href="epginfo.html\?epgid=
#line 18 "tooltip.ecpp"
  reply.sout() << ( domId );
  reply.out() << data[4]; // "\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::help_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("tooltip::help " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
std::string text = qparam.param("text");
  // </%args>

  // <%cpp>
  reply.out() << data[6]; // <img src="
#line 25 "tooltip.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "help.png") );
  reply.out() << data[7]; // " alt="" 
  // <& hint ...
  { 
#line 25 "tooltip.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 25 "tooltip.ecpp"
    _tnt_cq0.add( "text", tnt::toString((text), reply.out().getloc() ) );
#line 25 "tooltip.ecpp"
  main().hint(request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[8]; // ></img>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
